#!/bin/perl

#  #!# $Id: make_readnc.pl,v 1.1 2005/04/04 19:05:10 trn Exp $
# Quick and dirty script for IDL ingest of WRF netcdf files

use strict;
use File::Basename;

my $filename=$ARGV[0];
&help() if (!$filename or grep(/help/,$filename));
my $dumpfile="ncdump_".basename($filename);
my $outpro="readnc_".basename($filename);
my $outfile=$outpro.".pro";

## my $cmd="ncdump -h $filename > $dumpfile";
## system($cmd);
## print "Generated ncdump in: $dumpfile\n";
## open(INFILE,"<$dumpfile") or die "Cannot open infile: $dumpfile\n";
## my @inlines=(<INFILE>);
## close (INFILE) or die "Cannot close infile: $dumpfile\n";
my @inlines=`ncdump -h $filename`;
chomp @inlines;

open (OUTFILE,">$outfile") or die "Cannot open outfile: $outfile \n";
print OUTFILE "function $outpro\n";
print OUTFILE "Id = NCDF_OPEN('$filename')\n";
my @varnames;
foreach my $line (@inlines) {
  if ($line =~ /^\s+(char|float|int)\s+([^\(]+)/ ) {
    my $varname=$2;
    push @varnames, $varname;
    print OUTFILE "ncdf_varget, id, '$varname', $varname\n";
  } else {
    print OUTFILE "; $line\n";
  }
}
print OUTFILE 'result= {$'."\n";
foreach my $varname (@varnames) {
  print OUTFILE "         $varname : $varname, ".'$'."\n";
}
print OUTFILE "         filename:'$filename'}\n";
print OUTFILE "return, result\n";
print OUTFILE "end\n";
close (OUTFILE) or die "Cannot close outfile: $outfile\n";
print "Generated IDL procedure in: $outfile\n";
1;
sub help {
  print "$0 help message:
  This script generates an IDL procedure to read in all variables present in a 
  WRF netcdf file, and return them in an IDL struct.
  Arguments:
  required: WRF netcdf filename
";
  die "Usage: $0 filename\n";
}
