function unstagger,inarr,stagdim

; $Id: wrf-idl.pro,v 1.1 2005/04/04 19:05:10 trn Exp $
; procedure to unstagger WRF variable stored in array inarr, along
; dimension stagdim
; Usually: u - stagdim=1; v - stagdim=2
; Output array will have one fewer element than input array along stagdim

arrsiz = size(inarr)
ndims = arrsiz[0]
if (stagdim gt ndims) then begin
    print, "unstagger error: ndims, stagdim=",ndims, stagdim
    return, inarr
endif
nstag = arrsiz[stagdim] - 1
CASE ndims OF
    1: begin
        result= fltarr(nstag)
        for i=0,nstag-1 do begin
            result[i] = 0.5*(inarr[i]+inarr[i+1])
        endfor
    end
    2: begin
        CASE stagdim OF
            1: begin
                result=fltarr(nstag,arrsiz[2])
                for i=0,nstag-1 do begin
                    result[i,*] = 0.5*(inarr[i,*]+inarr[i+1,*])
                endfor
            end
            2: begin
                result=fltarr(arrsiz[1],nstag)
                for i=0,nstag-1 do begin
                    result[*,i] = 0.5*(inarr[*,i]+inarr[*,i+1])
                endfor
            end
        ENDCASE
    end
    3: begin
        CASE stagdim OF
            1: begin
                result=fltarr(nstag,arrsiz[2],arrsiz[3])
                for i=0,nstag-1 do begin
                    result[i,*,*] = 0.5*(inarr[i,*,*]+inarr[i+1,*,*])
                endfor
            end
            2: begin
                result=fltarr(arrsiz[1],nstag,arrsiz[3])
                for i=0,nstag-1 do begin
                    result[*,i,*] = 0.5*(inarr[*,i,*]+inarr[*,i+1,*])
                endfor
            end
            3: begin
                result=fltarr(arrsiz[1],arrsiz[2],nstag)
                for i=0,nstag-1 do begin
                    result[*,*,i] = 0.5*(inarr[*,*,i]+inarr[*,*,i+1])
                endfor
            end
        ENDCASE
    end
    4: begin
        CASE stagdim OF
            1: begin
                result=fltarr(nstag,arrsiz[2],arrsiz[3],arrsiz[4])
                for i=0,nstag-1 do begin
                    result[i,*,*,*] = 0.5*(inarr[i,*,*,*]+inarr[i+1,*,*,*])
                endfor
            end
            2: begin
                result=fltarr(arrsiz[1],nstag,arrsiz[3],arrsiz[4])
                for i=0,nstag-1 do begin
                    result[*,i,*,*] = 0.5*(inarr[*,i,*,*]+inarr[*,i+1,*,*])
                endfor
            end
            3: begin
                result=fltarr(arrsiz[1],arrsiz[2],nstag,arrsiz[4])
                for i=0,nstag-1 do begin
                    result[*,*,i,*] = 0.5*(inarr[*,*,i,*]+inarr[*,*,i+1,*])
                endfor
            end
            4: begin
                result=fltarr(arrsiz[1],arrsiz[2],arrsiz[4],nstag)
                for i=0,nstag-1 do begin
                    result[*,*,*,i] = 0.5*(inarr[*,*,*,i]+inarr[*,*,*,i+1])
                endfor
            end
        ENDCASE
    end
ENDCASE

return, result
end

