#!/bin/csh -f

#obsolete, use plot_oneday.pl instead

if ($?SAVED) then
 set rundir=$SAVED
else
 set rundir=/beehive/scratch/day14/trn/saved
endif
if ($?TMPTRN) then
 set tmpdir=$TMPTRN
else
 set tmpdir=/home/trn/junk
endif
if ($?NWPDIR) then
 set NWPDIR=$NWPDIR
else
 set NWPDIR=$HOME/NWP
endif

if ($#argv < 3) then
   echo "$0 aborting because supplied $#argv arguments"
   goto usage
endif
if ("a$1" == "ahelp" || "a$1" == "a-h" || "a$1" == "a-h") goto usage

mkdir $tmpdir/native
cd $tmpdir/native
if (-e $tmpdir/var_sample == 0) then
   echo "/bin/cp ${NWPDIR}/arl-format/data2arl/wrfgrib2arl/var_sample $tmpdir/var_sample"
   /bin/cp ${NWPDIR}/arl-format/data2arl/wrfgrib2arl/var_sample $tmpdir/var_sample
endif

set domain=$argv[1]
shift
set day=$argv[1]
shift
mkdir $tmpdir/native/$day
cd $tmpdir/native/$day
foreach hour ( $* )
# quick and dirty handling of date changes (assumes all in the same month)
 @ vday=$day
 @ vhour=$hour
 while ($vhour > 23) 
    @ vhour-=24
    @ vday++
 end
 set vsday=$vday
 if ($vday < 10) set vsday="0$vsday"
 set vshour=$vhour
 if ($vhour < 10) set vshour="0$vshour"
 ${NWPDIR}/native_util/wrf2native.pl -nodorotate -gribfile $rundir/200406$day/wrfout_${domain}_2004-06-${vsday}_${vshour}:00:00 -nativefile ${domain}_${hour}hr -parmfile parm_wrfgrib_stilt
 ${NWPDIR}/p1229/wrfv2/plot-stilt.pl -vfile $tmpdir/var_sample  -hr $hour -domain $domain
end

exit (0)

usage:
 echo "$0 Help message:"
 echo "obsolete, use plot_oneday.pl instead"
 echo "This script produces grads plots from wrfout files, using:"
 echo "- wrf2native.pl to reformat the WRF GRIB files to native"
 echo "- plot-stilt.pl to produce the plots, which uses the wrfgrib2arl control file var_sample to select variables to plot"
 echo "Arguments:"
 echo " 1 - domain (dnn)"
 echo " 2 - day (2-digit)"
 echo " 3 (or more) - hour(s) (2-digit)"
 echo "Path names from environment or defaults:"
 echo " rundir (SAVED; parent directory of 200406dd):"
 echo "  $rundir"
 echo " tmpdir (TMPTRN; destination directory for var_sample and native):"
 echo "  $tmpdir"
 echo " NWPDIR (NWPDIR; parent directory of AERNEWS, native, and arl-format cvs working directories):"
 echo "  $NWPDIR"
exit (1)
