#!/bin/csh -f

#redo postp_oneday.csh for selected dates.  Those stored in file $tmpdir/bad_dates.txt:
# one per line, as da:dd_hh (da - forecast day; dd, hh - valid day and hour)

if ($?SAVED) then
 set rundir=$SAVED
else
 set rundir=/beehive/scratch/day14/trn/saved
endif
if ($?TMPTRN) then
 set tmpdir=$TMPTRN
else
 set tmpdir=/beehive/scratch/day14/trn
endif
if ($?NWPDIR) then
 set rundir=$NWPDIR
else
 set rundir=$HOME/NWP
endif

mkdir $tmpdir/arl
cd $tmpdir/arl
if (-e $tmpdir/var_sample == 0) then
   echo "/bin/cp ${NWPDIR}/arl-format/data2arl/wrfgrib2arl $tmpdir/var_sample"
   /bin/cp ${NWPDIR}/arl-format/data2arl/wrfgrib2arl $tmpdir/var_sample
endif

@ kount=0
foreach line ( `cat $tmpdir/bad_dates.txt` )
  set day=`echo $line | cut -c1-2`
  set dahr=`echo $line | cut -c4-8`
  set ftail="wrfout_d01_2004-06-${dahr}:00:00"
  set gfile="$rundir/200406$day/$ftail"
  echo "Processing: $gfile"
      ${NWPDIR}/arl-format/data2arl/wrfgrib2arl/wrfgrib2arl \
      -P $tmpdir/var_sample \
      -H half_levels.txt -F full_levels.txt $gfile >&! $gfile:t.out
      foreach dfile ( DATA_*.WRF CFG_*.WRF )
        /bin/mv $dfile $gfile:t.$dfile
      end
end
