#!/bin/csh -f

# Sample install script for Release-1-n - this example works on AER's humboldt computer
# Issue this after untarring ("tar xzf WRF-STILT-Release-1-n.tar.gz")

setenv GEOG_DATAROOT /data/ncep-data/GEOG
setenv EXT_DATAROOT /scratch/white/day14/trn/extdata
setenv NETCDF /usr/local/netcdf/3.6.1
set mpihome=`which mpirun | sed 's/\/bin\/mpirun//'`

cd NWP/
cd WRFV2/
tar xf ../../WRFV2-patch.tar 
/bin/cp -p ../WRF_util/inhouse_util/configure.wrf.humboldt .
/bin/cp -p configure.wrf.humboldt configure.wrf
tar zxf ../mm5_tar/wrfsi.tar.gz 
tar xf ../../wrfsi-patch.tar 
./compile em_real >&! wrf-compile.out
cd wrfsi
perl install_wrfsi.pl --machine=humboldt --mpich=$mpihome \
--install_ui=n >&! wrfsi-install.out
cd ../../arl-format/
/bin/csh -xvf ./install-arl.csh xlf >&! install-arl.out
