cdis    Forecast Systems Laboratory
cdis    NOAA/OAR/ERL/FSL
cdis    325 Broadway
cdis    Boulder, CO     80303
cdis
cdis    Forecast Research Division
cdis    Local Analysis and Prediction Branch
cdis    LAPS
cdis
cdis    This software and its documentation are in the public domain and
cdis    are furnished "as is."  The United States government, its
cdis    instrumentalities, officers, employees, and agents make no
cdis    warranty, express or implied, as to the usefulness of the software
cdis    and documentation for any purpose.  They assume no responsibility
cdis    (1) for the use of the software and documentation; or (2) to provide
cdis     technical support to users.
cdis
cdis    Permission to use, copy, modify, and distribute this software is
cdis    hereby granted, provided that the entire disclaimer notice appears
cdis    in all copies.  All modifications to this software must be clearly
cdis    documented, and are solely the responsibility of the agent making
cdis    the modifications.  If significant modifications or enhancements
cdis    are made to this software, the FSL Software Policy Manager
cdis    (softwaremgr@fsl.noaa.gov) should be notified.
cdis
cdis
cdis
cdis
cdis
cdis
cdis

!       Miscellaneous Conversion Routines

!       Steve Albers           1990


        function k_to_f(x)
cdoc    Convert Kelvin to Fahrenheit
        real*4 k_to_f
        k_to_f = (x - 273.15) * 1.8 + 32.
        return
        end

        function f_to_k(x)
cdoc    Convert Fahrenheit to Kelvin
        real*4 f_to_k
        f_to_k = (x - 32.) / 1.8 + 273.15
        return
        end

        function k_to_c(x)
cdoc    Convert Kelvin to Celsius
        real*4 k_to_c
        k_to_c = (x - 273.15)
        return
        end

        function c_to_k(x)
cdoc    Convert Celsius to Kelvin
        real*4 c_to_k
        c_to_k = (x + 273.15)
        return
        end

        function f_to_c(x)
cdoc    Convert Fahrenheit to Celsius
        real*4 f_to_c
        f_to_c = (x - 32.) / 1.8 
        return
        end
c
        function c_to_f(t_c)
cdoc    Convert Celsius to Fahrenheit
        c_to_f = (t_c * 9./5.) + 32.             ! C to F
        return
        end
c
c

c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        subroutine conv_meters_to_inches(data_in, numarr,prodno,
     1  imax, jmax)
c   subroutine to convert accumulations meters to inches
        REAL*4 data_in(imax, jmax, numarr)
        Integer Prodno
c   begin
        do j=1,jmax
        do i=1,imax
          data_in(i,j,prodno) = data_in(i,j,prodno) / 0.0254
        enddo !i
        enddo !j
c
        return
        end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

